#include "motor.h"




  uint8_t Motor::pinPwmA;
  uint8_t Motor::pinPwmB;



void Motor::setMotorPwmPins(uint8_t a , uint8_t b){
  Motor::pinPwmA = a;
  Motor::pinPwmB = b;
}

void Motor::setMotorEnablePin(uint8_t enable){
  this->pinEnable = enable;
}


void Motor::setup(){
  ArduinoAnpassung::setup();
  Timer1.initialize(1000); // 10kHz
  //Timer1.attachInterrupt(Motor::interruptEinsprung);
  Timer1.pwm(Motor::pinPwmA, (0));  // 1023 
  Timer1.pwm(Motor::pinPwmB, (0));  // 1023 
  //digitalWrite(LED_BUILTIN , 0 );
}



void Motor::memberSetup(){
  pinMode(pinEnable , OUTPUT);
  digitalWrite( pinEnable , 0);
}



void Motor::memberLoop(){
  if(richtung){
    if(test == 32767)
      richtung = !richtung;
    else
      test ++;
  }else{
    if(test == -32767)
      richtung = !richtung;
    else
      test --;
  }
  setSollSpeed( test / 128);
  //setSollSpeed(100);
  
}


void Motor::setSollSpeed(int16_t speed){
  uint16_t pwm;

  if(speed >255)
    speed = 255;
  if(speed < -255)
    speed = -255;


  if(speed > 0)
   { 
    pwm = 512 + speed * 2;
    digitalWrite(pinA , 0);
    digitalWrite(pinB , 1);

  }else if (speed < 0){
    pwm = 512 - speed * 2;
    digitalWrite(pinA , 1);
    digitalWrite(pinB , 0);

  }else{
    pwm = 1023;
    digitalWrite(pinA , 0);
    digitalWrite(pinB , 0);

  }
  Timer1.pwm(Motor::pinPwm, pwm);
 

}




