#ifndef MOTOR_H
#define MOTOR_H

#include <TimerOne.h>
#include "pins.h"
#include "arduinoAnpassung.h"

class Motor :public ArduinoAnpassung{

public:
 
  
  //virtual ~Motor();

  static void setup();

  static void setMotorPwmPins(uint8_t a , uint8_t b);
  void setMotorEnablePin(uint8_t enable);

  void setSollSpeed(int16_t speed);

protected:

  
  static uint8_t pinPwmA;
  static uint8_t pinPwmB;

  void memberSetup();
  void memberLoop();

  //static void interruptEinsprung();
  //void memberInterruptEinsprung();
  //void InterruptEinsprung();

  void interruptBerechnungen();

  uint8_t pinEnable;
  uint16_t timer;

  int16_t sollSpeed; 
  int16_t summeSpeed;

  bool richtung;
  int16_t test;
  
};



#endif